# 
# Copyright (c) 2001 eMason.com. All rights reserved.
#

sub AddUser{
    # USAGE
    # register.cgi

    my($username, $password, $firstname, $lastname, $email, $telephone, $imType, $imIdentity, $zipcode) = @_;
    my($sth, $rv, $rv1, $rv2, $userId);
    
    # inserts into the user_info
    ($sth, $rv1) = QueryDB("INSERT INTO user_info (username, password, first_name, last_name, email, telephone, im_type, im_id, zipcode, created)
VALUES('$username','$password','$firstname','$lastname','$email','$telephone','$imType','$imIdentity','$zipcode',NOW())","Adding a new user into user table",$debug);
    
    my($userId);
    if ($mySqlVer >= 3.23){
	$userId = $sth->{'insertid'};
    } else {
	($sth, $rv) = QueryDB("SELECT LAST_INSERT_ID()","",$debug);
	$userId = $sth->fetchrow;
    }

    # inserts the required fields into the lookup table
    ($sth, $rv2) = QueryDB("INSERT INTO user_lookup (user_id, username, password, sessionkey) VALUES ('$userId','$username','$password',PASSWORD(CONCAT('$userId',NOW())))","Adding a new user into user_lookup",$debug);

    # track new user
    AddTracking("user_added",$username);

    if (($rv1 * $rv2) > 0){return 1;}
    else {return 0;}
}


sub UpdateUser{
    # USAGE
    # useraccount.cgi

    my($userId, $firstname, $lastname, $email, $telephone, $im_type, $im_id, $zipcode) = @_;    
    my $statement = qq[UPDATE user_info SET first_name = '$firstname', last_name = '$lastname', email = '$email', telephone = '$telephone', im_type='$im_type', im_id='$im_id', zipcode = '$zipcode' WHERE user_id = '$userId'];
    ($sth, $rv) = QueryDB($statement,"",$debug);
    return ($rv>0);
}

sub DeleteUser{
    # USAGE
    # useraccount.cgi

    my($userId) = @_;

    # get the username for tracking purposes
    my ($sth, $rv) = QueryDB("SELECT username FROM user_info WHERE user_id = '$userId'");
    my $username = $sth->fetchrow;
    
    # delete from inventory
    ($sth, $rv) = QueryDB("DELETE FROM item_inventory WHERE user_id = '$userId'");

    # delete from bookwatch
    ($sth, $rv) = QueryDB("DELETE FROM item_watch WHERE user_id = '$userId'");

    # delete from user_lookup
    ($sth, $rv) = QueryDB("DELETE FROM user_lookup WHERE user_id = '$userId'");

    # delete from user table
    ($sth, $rv) = QueryDB("DELETE FROM user_info WHERE user_id = '$userId'");

    #track the deletion
    AddTracking("user_removed",$username);

    return ($rv);
}

sub UpdatePassword{
    # USAGE
    # useraccount.cgi
    my($userId, $oldpassword, $newpassword) = @_;
    
    # update user_info
    ($sth, $rv) = QueryDB("UPDATE user_info SET password = '$newpassword' WHERE user_id = $userId AND password = '$oldpassword'","",$debug);

    # update user_lookup
    ($sth, $rv) = QueryDB("UPDATE user_lookup SET password = '$newpassword' WHERE user_id = $userId AND password = '$oldpassword'","",$debug);
    
    return ($rv > 0);
}

sub GetUserIdSessionKeyByUsernamePassword{
    my ($username,$password) = @_;
    my ($userId,$sessionKey,$sth,$rv);
    ($sth,$rv)=QueryDB("SELECT user_id, sessionkey 
                        FROM user_lookup 
	                WHERE username='$username'
	                AND password='$password'",
		       "GetUserIdByUsernamePassword",
		       $debug);
    if ($rv > 0){
	($userId,$sessionKey) = $sth->fetchrow_array;
	return ($userId,$sessionKey);
    } else {
	return;
    }
}

sub CheckUserIdPasswordExistance{
    my ($userId,$password) = @_;
    my($sth,$rv)=QueryDB("SELECT count(*) FROM user_lookup WHERE user_id='$userId' AND password='$password'",
		       "CheckUserIdPasswordExistance",
		       $debug);
    my($exists) = $sth->fetchrow_array;
    return ($exists);
}

sub GetUserIdBySessionKey{
    my ($sessionKey) = @_;
    my ($userId);
    my ($sth, $rv) = QueryDB("SELECT user_id FROM user_lookup
WHERE sessionkey = '$sessionKey'","",$debug);
    
    if ($rv > 0){
	($userId) = $sth->fetchrow_array;
	return ($userId);
    } else {
	return;
    }  
}

sub GetUsernameBySessionKey{
    my ($sessionKey) = @_;
    my ($username);
    my ($sth, $rv) = QueryDB("SELECT username FROM user_lookup
WHERE sessionkey = '$sessionKey'","",$debug);
    if ($rv > 0){
	($username) = $sth->fetchrow_array;
	return $username;
    } else {return;}
}


sub GetUserIdByUsername{
    my ($username) = @_;
    my ($userId);
    my ($sth, $rv) = QueryDB("SELECT user_id FROM user_lookup
WHERE username = '$username'","",$debug);

    if ($rv > 0){
	($userId) = $sth->fetchrow_array;
	return ($userId);
    } else {
	return;
    }  
}

sub GetUsernamePasswordByEmail{
    my ($email) = @_;
    my ($username,$password);
    my ($sth, $rv) = QueryDB("SELECT username, password FROM user_info
WHERE email = '$email'","GetUsernamePasswordByEmail",$debug);
    return ($rv, $sth->fetchall_arrayref);    

}

sub GetAllUserInfoByUserId{
   my ($userId) = @_;  
   my ($sth, $rv) = QueryDB("SELECT first_name, last_name, email, telephone, im_type, im_id, zipcode, username
                             FROM user_info
                             WHERE user_id = $userId","GetAllUserInfoByUserId",$debug);
   my ($firstName, $lastName, $email, $telephone, $imType, $imIdentity, $zipcode, $username) = $sth->fetchrow_array;
   return ($firstName, $lastName, $email, $telephone, $imType, $imIdentity, $zipcode, $username);    
}          


sub GetAllUserInfoByUserIdUsername{
   my ($userId,$username) = @_;  
   my ($sth, $rv) = QueryDB("SELECT first_name, last_name, email, telephone, im_type, im_id, zipcode, username
                             FROM user_info
                             WHERE user_id = $userId AND username = '$username'","GetAllUserInfoByUserId",$debug);
   my ($firstName, $lastName, $email, $telephone, $imType, $imIdentity, $zipcode, $username) = $sth->fetchrow_array;
   return ($firstName, $lastName, $email, $telephone, $imType, $imIdentity, $zipcode, $username);    
}          


sub CheckUsernameExistance{
    ($username) = @_;
    my($sth, $rv);
    ($sth, $rv) = QueryDB("SELECT username FROM user_info WHERE username='$username'","Check username existance",$debug);
    if ($rv==1){ return 1;}
    else {return;}
}


sub CheckEmailExistance{
    my($email) = @_;
    my($sth, $rv);
    ($sth, $rv) = QueryDB("SELECT email FROM user_info WHERE email='$email'","Check email existance",$debug);
    if ($rv==1){ return 1;}
    else {return;}
}



1;


