#!/usr/bin/perl 

# 
# Copyright (c) 2001 eMason.com. All rights reserved.
#

my $thisCGI="search.cgi";
require "utility.pl";
$|=1;

&ReadFormData;	
$op = $formData{'op'};

Header("","Search","search");
if ($op eq "search"){Search();}
elsif ($op eq "showitemsellers"){ShowItemSellers();}
elsif ($op eq "contactseller"){ContactSellerForm();}
elsif ($op eq "emailseller"){EmailSeller();}
else {ShowSearchForm();}
Footer();

sub ShowSearchForm {
    
    # obtain the list of courses.
    $courseOptions = GetCourseOptions($course);

    print qq[<br>
<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
<tr><td colspan=2 $s_loc_bar_bgcolor>$s_loc_bar_font_s &nbsp; Search </td></tr>
<tr><td>
<table border=0 cellpadding=2 cellspacing=2>

<form method=post action="search.cgi">
<input type=hidden name=op value="search">
<input type=hidden name=searchtype value="course">

<tr>
<td>$f <b> Course : </td>
<td><select name=query>$courseOptions</select>
</td><td><input align=absmiddle type=image src="$relImgDir/go1.gif" border=0></td>
</tr>
</form>


<form method=post action="search.cgi">
<input type=hidden name=op value="search">
<input type=hidden name=searchtype value="title">
<tr>
<td>$f <b> Title : </td>
<td><input type=text size=20 name=query></td>
<td><input align=absmiddle type=image src="$relImgDir/go1.gif" border=0></td>
</tr>
</form>


<form method=post action="search.cgi">
<input type=hidden name=op value="search">
<input type=hidden name=searchtype value="aux1">
<tr>
<td>$f <b> Author : </td>
<td><input type=text size=20 name=query></td>
<td><input align=absmiddle type=image src="$relImgDir/go1.gif" border=0></td>
</tr>
</form>


<form method=post action="search.cgi">
<input type=hidden name=op value="search">
<input type=hidden name=searchtype value="itemid">
<tr>
<td>$f <b> ISBN # : </td>
<td><input type=text size=20 name=query></td>
<td><input align=absmiddle type=image src="$relImgDir/go1.gif" border=0></td>
</tr>
</form>


<form method=post action="search.cgi">
<input type=hidden name=op value="search">
<input type=hidden name=searchtype value="username">
<tr>
<td>$f <b> Username : </td>
<td><input type=text size=20 name=query></td>
<td><input align=absmiddle type=image src="$relImgDir/go1.gif" border=0></td>
</tr>
</form>
</table>
</td>
<td valign=top>
$f You can also:
<br><b><a href="$thisCGI?op=search&searchtype=all">Show All Books Available</a></b>

</td>
</tr></table>

];
}


sub ShowItemSellers{
    my($itemInfoId) = @_;

    if ($itemInfoId eq ""){
	$itemInfoId=$formData{'iteminfoid'};
    }

    # track the item shown
    AddTracking("item_shown",$itemInfoId);

    print qq[<br><table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
<tr><td $s_loc_bar_bgcolor>$s_loc_bar_font_s &nbsp; Search Results - Sellers</td></tr>
	     </table> ];
    
    # get details of this item 
    # note, the itemType and itemId are required for CDB checks
    my ($itemType, $itemId, $title, $retailPrice, $author, $edition, $aux3, $aux4, $aux5, $aux6) = GetItemInfoByItemInfoId($itemInfoId);
    if ($edition < 1){$edition = "n/a";}    
    
    if ($retailPrice eq ""){$retailPrice = "n/a";}

    # print the details of the item.
    print qq[
<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
<tr><td valign=top>
$f <b>$title</b><br> by $author<font size=1><br> Edition:$edition &nbsp;Pages:$aux5 &nbsp;Format:$aux6 &nbsp;ISBN:$itemId<br> Date Published:$aux4 &nbsp;Publisher:$aux3 &nbsp; 
</font>
</td><td valign=bottom align=right>$f
<b> Retail Price: $retailPrice</b><br><font size=1>(<a href="http://www.bookhq.com/cgi-bin/search.cgi?op=search&searchterm=$itemId" target=_blank>Check&nbsp;online&nbsp;price</a>)</font>
<br><br>
<b><a href="itemwatch.cgi?op=additemwatch&searchtype=itemid&searchterm=$itemId">BookWatch this Book!</a></b>
</td></tr>
</table>
];

    # print the local sellers
    PrintItemSellersBySearchLocale("local", @{GetItemInventoryByItemInfoId($itemInfoId)});

    # get the appropriate data from CDB
    ($numResults, @CDBInventory) = GetInventoryFromCDB($itemType, "itemId", $itemId);

    # print the city sellers
    PrintItemSellersBySearchLocale("city", @CDBInventory);
    # print the state sellers
    PrintItemSellersBySearchLocale("state", @CDBInventory);
    # print the country sellers
    PrintItemSellersBySearchLocale("country", @CDBInventory);
    # print the world sellers
    PrintItemSellersBySearchLocale("world", @CDBInventory);
}

sub PrintItemSellersBySearchLocale {     
    my ($searchLocale, @dataSet)  = @_;
    
    %headerText = ("local","Local&nbsp;Results, $defaultArea",
		   "city","City&nbsp;Results, $defaultCity",
		   "state","State&nbsp;Results, $defaultState",
		   "country","Nation&nbsp;Results, $defaultCountry",
		   "world","Global&nbsp;Results, $defaultWorld",
		   );

    foreach $item (keys %headerText){
	$headerText{$item} =~ s/ /\&nbsp\;/g;
    }

    if ($searchLocale eq "local"){
	# get the list of people that are selling this item - LOCAL
	# $inventoryTable = GetItemInventoryByItemInfoId($itemInfoId);

	# print the appropriate header
	print qq[ 
<table border=0 cellpadding=2 cellspacing=0 width=$bodyWidth>
<tr><td $s_header_bgcolor> $f&nbsp;<b>$headerText{'local'}</b> </td><td width=100%>&nbsp;</td></tr></table><table border=0 cellpadding=0 cellspacing=0 width=$bodyWidth height=1 $s_header_bgcolor><tr><td><img src="$relImgDir/pix.gif" width=1 height=1></td></tr></table>
		  ];	
	# print the sellers
	if ($#dataSet !=  -1){
	    print qq[
<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
<tr>
  <td width=50>$s_header_font_s Price $s_header_font_e</td>
  <td width=80>$s_header_font_s Condition $s_header_font_e</td>
  <td width=100>$s_header_font_s Seller $s_header_font_e</td>
  <td width=390>$s_header_font_s Comments $s_header_font_e</td>
</tr>
		     ];
	    
	    my($i);
	    for $i ( 0 .. $#dataSet ) {
		$lineCount = $i;
		if ($lineCount%2==0){$alt_bgcolor="bgcolor=#efefef";} 
		else {$alt_bgcolor="";}
		my ($sellerId, $itemInventoryId, $condition, $askPrice, $comments, $sellerUsername) = @{$dataSet[$i]};
		print qq[
<tr $alt_bgcolor>
  <td>&nbsp;$f$askPrice</td>
  <td>&nbsp;$f$conditionSet{$condition}</td>
  <td>&nbsp;$f<a href="$thisCGI?op=contactseller&seller=$sellerUsername&iteminventoryid=$itemInventoryId">$sellerUsername</a></td>
  <td>&nbsp;$f$comments</td>
</tr>
			 ];
	    }
	    print qq[</table>];
	
	} else {
	    print qq[$f None available];    
	}
	
    } else {

	    print qq[
<table border=0 cellpadding=2 cellspacing=0 width=$bodyWidth>
<tr><td $s_header_bgcolor>$f&nbsp;<b>$headerText{$searchLocale}</b>&nbsp;</td>
<td width=100%>&nbsp;</td></tr></table>
<table border=0 cellpadding=0 cellspacing=0 width=$bodyWidth height=1 $s_header_bgcolor><tr><td><img src="$relImgDir/pix.gif" width=1 height=1></td></tr></table>
		     ];	    

	    my ($resultCount,$resultText);
	    
	    foreach $resultLine (@dataSet) {
		($numResults, $geoLimit, $sellerUsername, $title, $aux1, $aux2, $condition, $price, $location, $comments, $contactUrl) = split(/\|/,$resultLine);
		if ($geoLimit eq "$searchLocale"){
		    $resultCount++;
		    if ($resultCount%2){$alt_bgcolor="bgcolor=#efefef";} 
		    else {$alt_bgcolor="";}
		    $resultText .= qq[
<tr $alt_bgcolor>
  <td>&nbsp;$f$price</td>
  <td>&nbsp;$f$conditionSet{$condition}</td>
  <td>&nbsp;$f<a href="$contactUrl" target=_blank>$sellerUsername</a></td>
  <td>$f$location$fe</td>
  <td>&nbsp;$f$comments</td>
</tr>
		     ];		    
		}
	    }

	    if ($resultCount < 1){
		print qq[$f None available];    
	    } else {
	print qq[
<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
<tr>
  <td width=50>$s_header_font_s Price $s_header_font_e</td>
  <td width=80>$s_header_font_s Condition $s_header_font_e</td>
  <td width=100>$s_header_font_s Seller $s_header_font_e</td>
  <td width=100>$s_header_font_s Location $s_header_font_e</td>
  <td width=290>$s_header_font_s Comments $s_header_font_e</td>
</tr>
$resultText
</table>];	

	
	    }
	}

    return;
}



sub ContactSellerForm{

    $itemInventoryId = $formData{'iteminventoryid'};
    $ownerUsername = $formData{'seller'};
    
    # get the user details, and item details. print out form
    ($ownerId, $ownerFirstName, $ownerLastName, $ownerTelephone, $ownerImType, $ownerImIdentity, $ownerZipCode, $itemInfoId, $sellerTitle, $sellerAux1, $sellerCondition, $sellerComments, $sellerAskPrice) = GetItemInventoryAndUserDetailsByItemInventoryIdUsername($itemInventoryId, $ownerUsername);

    if ($ownerTelephone ne ""){$ownerContactText .= "Tel:$ownerTelephone ";}
    if ($ownerImIdentity ne ""){$ownerContactText .= "$imSet{$ownerImType}:$ownerImIdentity";}
    if ($ownerContactText ne ""){$ownerContactText = "<br>$ownerContactText";}

    
    # STANDARD book information
    my ($itemType, $itemId, $title, $retailPrice, $author, $edition, $aux3, $aux4, $aux5, $aux6) = GetItemInfoByItemInfoId($itemInfoId);
    if ($edition < 1){$edition = "n/a";}
    
    if ($retailPrice eq ""){$retailPriceText = "n/a";}
    else {$retailPriceText = "\$$retailPrice";}

    print qq[<br><table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
<tr><td $s_loc_bar_bgcolor>$s_loc_bar_font_s &nbsp; Contact Seller</td></tr> </table> ];

print qq[
<!-- Basic Information on the book / seller / location -->
<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth><tr>
<td width=320 valign=top $s_header_bgcolor>$s_header_font_s Item: </td>
<td width=320 valign=top $s_header_bgcolor>$s_header_font_s Seller: </td>

</tr><tr>

<td width=320 valign=top>
$f <b>$title</b>
<br> by $author
<font size=1>
<br> Edition:$edition &nbsp;Pages:$aux5 &nbsp;Format:$aux6 &nbsp;ISBN:$itemId
<br> Date Published:$aux4 &nbsp;Publisher:$aux3 &nbsp; 
</font>
</td>


<td width=320 valign=top>$f 
<b>$ownerFirstName $ownerLastName</b> <font size=1>(<a href="search.cgi?op=search&searchtype=username&query=$ownerUsername">other books by seller</a>)</font>
<br>$defaultArea - $ownerZipCode
<font size=1><br>$defaultCity, $defaultState 
$ownerContactText 
<br><font size=1>Comments: $sellerComments
<br>Condition: $conditionSet{$sellerCondition}
</font>
</td>

</tr>
<tr>
<td>$f<b> Retail: $retailPriceText </b><font size=1>(<a href="http://www.bookhq.com/cgi-bin/search.cgi?op=search&searchterm=$itemId" target=_blank>Current&nbsp;online&nbsp;price</a>)</font></td>
<td>$f<b>Asking Price: $sellerAskPrice</b></td>
</tr>
</table>


<table border=0 cellspacing=2 cellpadding=2 width=$bodyWidth>

<form method=post action="$thisCGI">
<input type=hidden name=op value="emailseller">
<input type=hidden name=iteminventoryid value="$itemInventoryId">
<input type=hidden name=ownerid value="$ownerId">

<tr><td align=center colspan=2 $s_header_bgcolor>$s_header_font_s <b> Send a message to the seller </b> $fe </td></tr> 
<tr><td>$f Subject: $fe</td><td><input type=text name=subject value="RE: $title" size=50></td></tr>
	 <tr><td valign=top>$f Message: $fe</td>
<td><textarea name=message rows=12 cols=40>
$ownerFirstName $ownerLastName,
I'm interested in your posted item,
"$title"
by $author

Listed at \$$sellerAskPrice

I'm willing to pay you \$$sellerAskPrice for it.
</textarea></td><tr>
<tr><td>$f Your Name: $fe</td><td><input type=text name=fromname value=""></td></tr>
<tr><td>$f Your Email: $fe</td><td><input type=text name=fromemail value=""> $s_example_font_s yourname\@yourisp.com</td></tr>
<tr><td>$f Your Phone: $fe</td><td><input type=text name=fromphone value=""> $s_example_font_s for the seller to contact you</td></tr>
<tr><td>$f Copy? $fe </td><td><input type=checkbox name=sendcopy value=yes> $f Send a copy back to you.</td></tr>
<tr><td></td><td><input type=submit></td></tr>
</table>
</form>


];

}


sub EmailSeller{

    # get the user details.
    $ownerId = $formData{'ownerid'};
    $itemInventoryId = $formData{'iteminventoryid'};
    $subject = $formData{'subject'};
    $message = $formData{'message'};
    $fromName = $formData{'fromname'};
    $fromEmail = $formData{'fromemail'};
    $fromPhone = $formData{'fromphone'};
    $sendCopy = $formData{'sendcopy'};

    $message .= "\n\nUser Contact Info\nName : $fromName\nEmail: $fromEmail\nPhone: $fromPhone";
    
    $message .= "\n\n nb. Please update your listings if you have sold your items.";
    
    if(CheckItemInventoryIdUserIdExists($itemInventoryId,$ownerId) != 1){
	print qq[Error. Please contact the webmaster.];
	print qq[</td></tr></table>];
	exit;
    }
    
    ($firstName, $lastName, $ownerEmail) = GetAllUserInfoByUserId($ownerId);
    $ownerName = "$firstName $lastName";


    SendMail($ownerName, $ownerEmail, $fromName, $fromEmail, $subject, $message);
    
    #send copy?
    if ($sendCopy eq "yes"){
	$subject = "Copy - $subject";
	SendMail($fromName, $fromEmail, $fromName, $fromEmail, $subject, $message);
    }

    # track the contact made
    AddTracking("contact_sent");

    print qq[$f <br> <center> <b> Email has been sent. </b> Search Again? <br>];
    ShowSearchForm();
}

sub Search{
    $searchType = $formData{'searchtype'};
    $query = $formData{'query'};
    $start = $formData{'start'};

    if ($searchType ne "all" && $query eq ""){
	ShowSearchForm(); print qq[</td></tr></table>]; Footer(); exit;
    }
    
    if ($searchType ne "itemid"){
	print qq[<br><table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
<tr><td $s_loc_bar_bgcolor>$s_loc_bar_font_s &nbsp; Search Results - Matching Items</td></tr> </table>]; 
    }
    
    if ($searchType eq "itemid"){
	
	# check the itemId
	if (!VerifyIsbn($query)){
	    ErrorMsg("ISBN# invalid. Please check your ISBN #.");
	    }
	CheckErrors();

	$query =~ /([0-9x]+)/i;
	$query =~ $1;
	
	($itemInfoId) = GetItemInfoIdByItemTypeItemId('%',$query);

	# track the search
	AddTracking("itemid_search",$query);
	
	if ($itemInfoId){
	    ShowItemSellers($itemInfoId);
	} else {
	    print qq[$f <br><b>No results. Search again.</b>];
	}
    } elsif ($searchType eq "all"){
	# track the search
	AddTracking("all_search");
	$itemTable = GetAllItemInventory('%',$start);
	DisplaySearchResults($itemTable);
	if ($#{$itemTable} >= 19){
	    print qq[$f<br><b><a href="$thisCGI?op=search&searchtype=$searchType&start=],$start+20,qq[">More books >>>>>  </a></b>];
	}

    } elsif ($searchType eq "title") {
	# track the search
	AddTracking("title_search",$query);
	$itemTable = GetItemInfoByItemTypeTitle('%',$query);
	DisplaySearchResults($itemTable);

	$encodedQuery = EncodeData($query); 
	$bookWatchText = qq[<b><a href="itemwatch.cgi?op=additemwatch&searchtype=title&searchterm=$encodedQuery">BookWatch this title - $query!</a></b>];

    } elsif ($searchType eq "aux1") {
	# track the search
	AddTracking("aux1_search",$query);
	$itemTable = GetItemInfoByItemTypeAux1('%',$query);
	DisplaySearchResults($itemTable);

	$encodedQuery = EncodeData($query);
	$bookWatchText = qq[<b><a href="itemwatch.cgi?op=additemwatch&searchtype=aux1&searchterm=$encodedQuery">BookWatch this author - $query!</a></b>];
	
    } elsif ($searchType eq "course"){
	# track the search
	AddTracking("course_search",$query);
	$itemTable = GetItemListByCourse($query);
	DisplaySearchResults($itemTable);

	$encodedQuery = EncodeData($query);
	$bookWatchText = qq[<b><a href="itemwatch.cgi?op=additemwatch&searchtype=course&searchterm=$encodedQuery">BookWatch this course - $query!</a></b>];

    } elsif ($searchType eq "username"){
	# track the search
	AddTracking("user_search",$query);
	$searchNameId = GetUserIdByUsername($query);
	if ($searchNameId){$itemTable = GetItemInventoryByUserId($searchNameId);}
	DisplaySearchResults($itemTable, "direct", $query);
	
    } else {
	# error message. 
	print qq[Please select a valid search option.];
	print qq[</td></tr></table>];
	exit;
    }
    
    print qq[<br>$f $bookWatchText];
}


sub DisplaySearchResults{
    my ($itemTable, $linkType, $searchName) = @_;
    if ($#{$itemTable} != -1){
	my ($i);
	if ($linkType eq "direct"){
	    # for username searches
	    print qq[<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth><tr $s_header_bgcolor><td>$s_header_font_s Course</td>
<!--<td>$s_header_font_s ISBN\# </td>-->
<td> $s_header_font_s Title</td><td> $s_header_font_s Author(s)</td><td> $s_header_font_s Edition</td><td>$s_header_font_s Price</td><td>$s_header_font_s Contact</td></tr>];
	    
	    for $i ( 0 .. $#{$itemTable} ){
		if ($i%2){$alt_bgcolor="bgcolor=#cccccc";} 
		else {$alt_bgcolor="";}

		my $title = $itemTable->[$i][5];
		my $author = $itemTable->[$i][6];

		my $edition = $itemTable->[$i][7];
		if ($edition < 1 || $edition > 100){$edition="";}

		my $price = $itemTable->[$i][8];
		if ($price ne ""){$price =~ s/\$//g; $price = "\$$price";}

		print qq[<tr $alt_bgcolor>
<td>&nbsp;$f$itemTable->[$i][4]</td>
<td>$f$title</td>
<td>$f$author</td>
<td>&nbsp;$f$edition</td>
<td>&nbsp;$f$price</td>
<td>&nbsp;$f<a href="$thisCGI?op=contactseller&seller=$searchName&iteminventoryid=$itemTable->[$i][0]">$searchName</a></td>
</tr>
			 ];
	    }
	    print qq[</table>];

	    
	} else {

	    print qq[
<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth><tr $s_header_bgcolor><td>$s_header_font_s ISBN\# </td><td>$s_header_font_s Title</td><td>$s_header_font_s Author(s)</td><td>$s_header_font_s Ed. </td><td>$s_header_font_s List </td></tr>];
	
	    for $i ( 0 .. $#{$itemTable} ){

		$price = $itemTable->[$i][4];
		if ($price ne ""){$price =~ s/\$//g; $price = "\$$price";}

		my $edition = $itemTable->[$i][6];
		if ($edition < 1){$edition="";}
		
		if ($i%2){$alt_bgcolor="bgcolor=#efefef";} 
		else {$alt_bgcolor="";}		
		
		print qq[<tr $alt_bgcolor>
<td>$f $itemTable->[$i][2]</td>
<td>$f <a href="$thisCGI?op=showitemsellers&iteminfoid=$itemTable->[$i][0]">$itemTable->[$i][3]</a></td>
<td>$f $itemTable->[$i][5]</td>
<td>$f $edition</td>
<td>$f $price</td>
</tr>
			 ];
	    }
	    print qq[</table>];
	}
    
    } else {

	print qq[<table border=0 width=$bodyWidth>
		 <tr><td valign=center align=center>$f <b> No results found. Please search again. </b>$fe </td></tr></table>];

    }
    
}




