#!/usr/bin/perl 

# 
# Copyright (c) 2001 eMason.com. All rights reserved.
#

my $thisCGI="sellitem.cgi";
require "utility.pl";
my $userId = CheckLogin($thisCGI);

Header("","Sell Book","sell");
ReadFormData();	
$op = $formData{'op'};
if ($op eq "coursechoice"){CourseChoice();}
elsif ($op eq "isbnchoice") {IsbnChoice();}
elsif ($op eq "showform") {ShowForm();}
elsif ($op eq "addnewitem") {AddNewItem();}
else {ShowChoices();}
Footer();


# isbn or class
# if ISBN
#    then ask for class (if any)
#    th

sub ShowChoices{
    ($course) = @_;

    
    $courseOptions = GetCourseOptions($course);

    print qq[<br>
<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth><tr $s_loc_bar_bgcolor><td>$s_loc_bar_font_s &nbsp;  Add new book - Step 1 of 3</td></tr>
<tr><td>$f

You have 3 ways to add your book. Option A. Select a listed course, if your course isn't listed, use Option B: Enter your course, and if the book doesn't have a course, you can used option C.

<table border=0 width=100%>
<form method=post action="$thisCGI">
<input type=hidden name=op value=coursechoice>
<tr>
<td>$f <b>A:</b></b></td>
<td>$f Select a course  </td>
<td> <select name=course>$courseOptions</select> </td>
<td width=120> <input type=image border=0 src="$relImgDir/continue.gif"></td>
</tr>
</form>

<form method=post action="$thisCGI">
<input type=hidden name=op value=coursechoice>
<tr>
<td>$f <b>B:</b> </td>
<td>$f Course not listed? </td>
<td> <input type=text name=newcourse> </td>
<td> <input type=image border=0 src="$relImgDir/continue.gif"></td>
</tr>
</form>

<form method=post action="$thisCGI">
<input type=hidden name=op value=isbnchoice>
<tr>
<td>$f <b>C:</b> </td>
<td>$f No particular course? <br> Enter the ISBN # </td>
<td> <input type=text name=isbn value="$isbn"> </td>
<td> <input type=image border=0 src="$relImgDir/continue.gif"></td>
</tr>
<tr><td colspan=2></td><td colspan=2> $f <font size=1> the ISBN# is a 10-digit number located at the back of your book </font ></td></tr>
</form>
</table>

</td>
</tr>
</table>
];
}


sub CourseChoice {
    my($course) = $formData{'course'};
    my($newCourse) = $formData{'newcourse'};
    my($noCourse) = $formData{'nocourse'};

    if ($newCourse ne ""){$course = $newCourse;}
    if ($noCourse eq "yes"){$course = "";}

    print qq[<br>
<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
<tr $s_loc_bar_bgcolor><td>$s_loc_bar_font_s &nbsp; Add new book - Step 2 of 3</td></tr>
</table>

<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
<tr><td> $f <b>Course: $course</b> </tr></td></table>
];
    
    # we will check in anycase whether the course has 
    # been previously entered before, and obtain the list of 
    # items that was used in the course.

    $itemTable = GetItemListByCourse($course);

    if ($#{$itemTable} != -1){
	print qq[
<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
<tr><td colspan=5>
$f If your book is listed, select the item to continue. If it isn\'t listed, enter the ISBN\# of the book below.</td></tr>
<tr $s_header_bgcolor><td>$f<b>ID</td><td>$f<b> Title</td><td>$f<b> Author</td><td>$f<b> Edition</td><td>$f<b> Price</td></tr>];
        my ($i);
	for $i ( 0 .. $#{$itemTable} ){
	    my $itemInfoId = $itemTable->[$i][0];
	    my $itemId = $itemTable->[$i][2];
	    my $title = $itemTable->[$i][3];
	    my $price = $itemTable->[$i][4];
	    my $author = $itemTable->[$i][5];
	    my $edition = $itemTable->[$i][6];
	    
#	    my ($itemInfoId, $itemType, $itemId, $title, $price, $author, $edition) = $itemTable->[$i];
	    if ($edition == 0){$edition = "";}

	    if ($i%2){$alt_bgcolor="bgcolor=#efefef";} 
	    else {$alt_bgcolor="";}

	    print qq[<tr $alt_bgcolor>
<td>$f$itemId</td>
<td>$f<a href="$thisCGI?op=showform&course=$course&iteminfoid=$itemInfoId">$title</a></td>
<td>$f$author</td>
<td>$f$edition</td>
<td>$f$price</td>
</tr>
];
	}
	print qq[</table>];
	print qq[<br>$f If your book is not listed, please enter the ISBN of the book.];
    }
    
    # this is a course that hasn't been entered before. 
    # We will have to default to ISBN
    print qq[
	     <table border=0><tr><td>
	     <form method=post action="$thisCGI">
	     $f ISBN # : $fe
	     <input type=hidden name=op value=isbnchoice>
	     <input type=hidden name=itemtype value="book">
	     <input type=text name=isbn value="$isbn">
	     <input type=hidden name=course value="$course">
	     <input type=submit value="Continue >>>>>">

	     <br> $f <font size=1> the isbn # is a 10-digit number located at the back of your book.</font>
	     </form>
	     If this is <b>not a book</b>, select one of this options.
	     <li> <a href="$thisCGI?op=showform&itemtype=bulkpack&course=$course">I have a bulkpack to sell >>>>>> </a>
	     <li> <a href="$thisCGI?op=showform&itemtype=equipment&course=$course">I have equipment for this class to sell >>>>>></a>
	     </td></tr></table>
	     ];	
    
}

sub IsbnChoice {
    # book specific function. Can easily be extended for other items.
    my($isbn) = $formData{'isbn'};
    my($course) = $formData{'course'};

    if (!VerifyIsbn($isbn)){
	ErrorMsg("ISBN# invalid. Please check your ISBN #.");
    }
    CheckErrors();
    $isbn =~ /([0-9x]+)/i;
    $isbn =~ $1;
    
    # search for the appropriate book information, and prefill the form.

    my ($status,$itemInfoId, $itemType, $itemId, $title, $retailPrice, $aux1, $aux2, $aux3, $aux4, $aux5, $aux6) = GetItemInfoByItemTypeItemId("book",$isbn);
    
    # there is a distinct possibility that there will be no information on 
    # the book entered. 
    ShowForm("book",$course,$itemInfoId,$isbn,$title,$price,$aux1,$aux2);

}


sub ShowForm {
    ($itemType, $course, $itemInfoId, $itemId, $title, $retailPrice, $aux1, $aux2) = @_;

	print qq[<br>
<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
		 <tr $s_loc_bar_bgcolor><td colspan=3>$s_loc_bar_font_s &nbsp; Add new book - Step 3 of 3 </td></tr></table>];

    if ($itemType eq ""){$itemType = $formData{'itemtype'};}

    if ($itemId eq ""){
	$course = $formData{'course'};
	$itemInfoId = $formData{'iteminfoid'};
    }

    if ($itemInfoId ne ""){
	# get the specific info for the item.
	($itemType, $itemId, $title, $retailPrice, $aux1, $aux2, $aux3, $aux4, $aux5, $aux6) = GetItemInfoByItemInfoId($itemInfoId);
    } 
    if ($retailPrice eq ""){$retailPriceText = "n/a";} 
    else {$retailPriceText = "\$$retailPrice";}
    if ($itemType eq "book" && $aux2 < 1){$aux2 = "";}

    if ($itemType eq "book" && $itemInfoId ne ""){
	my ($itemType, $itemId, $title, $retailPrice, $author, $edition, $aux3, $aux4, $aux5, $aux6) = GetItemInfoByItemInfoId($itemInfoId);

	if ($edition < 1){$edition = "n/a";}    
print qq[<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
<tr><td>
$f <b>$title</b>
<br> by $author
<font size=1>
<br> Edition:$edition &nbsp;Pages:$aux5 &nbsp;Format:$aux6 &nbsp;ISBN:$itemId
<br> Date Published:$aux4 &nbsp;Publisher:$aux3 &nbsp; 
</font>
</td>
<td valign=top align=right>$f<b> Retail Price: $retailPriceText</b>
<font size=1>
<br><a href="$relCgiDir/search.cgi?op=search&searchtype=itemid&query=$itemId" target=_blank>Check local price</a>
<br><a href="http://www.bookhq.com/cgi-bin/search.cgi?op=search&searchterm=$itemId" target=_blank>Check online price</a>
</font></td></tr>
</table>
];
    }

    print qq[
<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
<form method=post action="$thisCGI">
<input type=hidden name=op value="addnewitem">
<input type=hidden name=itemtype value="$itemType">
<tr $s_header_bgcolor><td colspan=3>$s_header_font_s Details </td></tr>

	     ];

    if ($course eq ""){
	$courseOptions = GetCourseOptions($course);
	print qq[
<tr>
  <td valign=top> $f_fs Course </td>
  <td> $f Select a course : <select name=course><option value="">Select a course $courseOptions<select>
	 <br>Course not listed? Enter here : <input type=text name=newcourse value=$newcourse> 
       <br>Not used in any specific course <input type=checkbox name=nocourse value='yes' checked>
  </td>
  <td> $ef$course_error </td>
</tr>
		 ];
    } else {
	# print out the pre-entered course
	print qq[
<tr>
  <td> $f_fs <b> Course </td>
  <td> $f $course <input type=hidden name=course value="$course"> </td>
</tr>
		 ];	    
    }
    
    print qq[
<tr>
  <td> $f_fs Title </td>
  <td> <input type=text name=title value="$title" size=55> </td>
</tr>
	     ];

    if ($itemType eq "book"){
	print qq[
<tr>
  <td> $f_fs Author(s) </td>
  <td> <input type=text name=aux1 size=55 value="$aux1"> </td>
</tr>

<tr>
  <td> $f_fs ISBN </td>
  <td> <input type=text name=itemid value="$itemId" size=12> </td>
</tr>

<tr>
  <td> $f_fs Edition </td>
  <td> <input type=text name=aux2 size=2 maxlength=2 value="$aux2"></td>
</tr>
];
    } else {
	# CatchAll item type is Other.
	print qq[
<tr>
  <td> $f_fs Description </td>
  <td> <textarea name=aux1 rows=10 cols=30>$description</textarea></td>
</tr>
		 ];
    }

    
    if ($retailPrice ne ""){
	# $retailPriceText  = "$f List: \$$retailPrice <input type=hidden name=price value='$retailPrice'>";
    } else {$retailPriceText = "";}

    if (VerifyIsbn($itemId)){ $checkOnlineText = qq[$f <a href="http://www.bookhq.com/cgi-bin/search.cgi?op=search&searchterm=$itemId" target=_blank>Check Online Pricing</a>];}

    $conditionOptions = GetConditionOptions();
    print qq[
<tr>
  <td> $f_fs Condition </td>
  <td> <select name=condition>$conditionOptions</select></td>
</tr>

<tr>
  <td> $f_fs Ask Price</td>
  <td> <input type=text name=askprice value="$askPrice" size=5 value="\$"> $checkOnlineText 
</td>
</tr>

<tr>
  <td> $f_fs Comments </td>
  <td> <textarea name=comments rows=5 cols=30>$comments</textarea></td>
</tr>
<tr>
  <td colspan=3><center><input type=submit value="Add New Item >>>>>"></center></td>
</tr>
	     </form>	     
	     </table>


	     ];
    
}



sub AddNewItem {
    
    $itemType = $formData{'itemtype'};
    $itemId = $formData{'itemid'};
    $course = $formData{'course'};
    $title = $formData{'title'};
    $aux1 = $formData{'aux1'};
    $aux2 = $formData{'aux2'};
    $condition = $formData{'condition'};
    $askPrice = $formData{'askprice'};
    $comments = $formData{'comments'};
    $retailPrice = $formData{'retailprice'};

    $newCourse = $formData{'newcourse'};    
    if ($newCourse ne ""){$course = $newCourse;}
    
    $noCourse = $formData{'nocourse'};
    if ($noCourse eq "yes"){$course = "";}

    AddItemToDB($userId, $itemType,$itemId,$course,$title,$aux1,$aux2,$condition,$retailPrice,$askPrice,$comments);

    print qq[<br>
<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
<tr $s_loc_bar_bgcolor><td colspan=3>$s_loc_bar_font_s &nbsp; Add new book - Done! </td></tr>
	     <tr><td>
$f <b> "$title" </b>added. Continue adding more books below. 
<br>
</td></tr>
</table>	     
];
    
    ShowChoices($course);

}










